
%{
#include <stdlib.h>
#include "ray.tab.h"
YYSTYPE raylval;
/*
#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
    { \
    int c = getchar(); \
    result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \
    }
*/
extern char *strsave(char *);
%}

alpha	[a-zA-Z]
special	[\.\_-]
digit	[0-9]
exp	[Ee][-+]?{digit}+
string	{alpha}({alpha}|{digit}|{special})*
filename "/"?"/"?(("."|".."|{string})"/")*{string}

%x comment

%%
[ \t\n\r]		;              /* white space */

ambient		return tAMBIENT;
diffuse		return tDIFFUSE;
specular	return tSPECULAR;
reflective	return tREFLECTIVE;
transparent	return tTRANSPARENT;
index		return tINDEX;
specpow		return tSPECPOW;
reflect		return tREFLECT;
transp		return tTRANSP;

pointlight	return tPOINTLIGHT;
light		return tLIGHT;
point		return tPOINT;
extended	return tEXTENDED;
extendedlight return tEXTENDEDLIGHT;

eyep		return tEYEP;
fov			return tFOV;
lookp		return tLOOKP;
up			return tUP;
screen		return tSCREEN;

scale		return tSCALE;
translate	return tTRANSLATE;
rotate		return tROTATE;

name		return tNAME;
list		return tLIST;
end			return tEND;
object		return tOBJECT;
surface		return tSURFACE;
applysurf	return tAPPLYSURF;
texture		return tTEXTURE;
image		return tIMAGE;

background	return tBACKGROUND;
sphere		return tSPHERE;
plane		return tPLANE;
triangle	return tTRIANGLE;

"/*"         BEGIN(comment); /* ignore C comments */
<comment>[^*]*        /* eat anything that's not a '*' */
<comment>"*"+[^*/]*   /* eat up '*'s not followed by '/'s */
<comment>"*"+"/"        BEGIN(INITIAL);

{digit}+ |
{digit}+"."{digit}*({exp})? |
{digit}*"."{digit}+({exp})? |
{digit}+{exp}		{raylval.double_type = atof(yytext); return DOUBLE_NUM;}
"-"			return tMINUS;
"+"			return tPLUS;
{string}	{raylval.string_pointer = strsave(yytext); return tSTRING;};

%%

#include <string.h>

/*
 * Allocate space for a string, copy string into space.
 *
 * Add your own error function call!
 */
char *
strsave(char *s)
{
        char *tmp;

        if (s == (char *)NULL)
                return (char *)NULL;

        if((tmp = (char *)malloc((unsigned)strlen(s) + 1)) == NULL)
			return (char *)NULL;	/* CALL YOUR ERROR CODE */
        (void)strcpy(tmp, s);
        return tmp;
}

